#ifndef DEFINITION_REALS
#include "REALS.h"
#endif
#include "REALLIB.h"
#define DEFINITION_COMPLEX

// Definition of class COMPLEX ********************

class COMPLEX : public REALMATRIX
{
public:

// Constructors: -------------------------------

COMPLEX();
COMPLEX(const REAL& real_part);
COMPLEX(const REALMATRIX&);
COMPLEX(const REAL& real_part, const REAL& imag_part);

// Copy Constructor: ---------------------------

// (already defined in base class REALMATRIX)

// Standard Arithmetic: ------------------------

friend COMPLEX  operator +  (const COMPLEX& x,
                             const COMPLEX& y);
friend COMPLEX  operator -  (const COMPLEX& x,
                             const COMPLEX& y);
friend COMPLEX  operator -  (const COMPLEX& x);
friend COMPLEX  operator *  (const COMPLEX& x,
                             const COMPLEX& y);
friend COMPLEX  operator /  (const COMPLEX& x,
                             const COMPLEX& y);

friend REAL real(const COMPLEX& z);
friend REAL imag(const COMPLEX& z);
friend REAL abs (const COMPLEX& z);

};

// complex square roots:

// defined for any complex number:
COMPLEX  sqrt(const COMPLEX& z);

// only defined for |z| > 0 (faster if |z| >> 0 ) :
COMPLEX csqrt(const COMPLEX& z);
