#include <setjmp.h>
#include "stdio.h"
#include "REALS.h"

inline long min(long a,long b)        
   { return (a < b ? a : b); };
inline long max(long a,long b)
   { return (a < b ? b : a); };
inline long max3(long a,long b,long c)
   { return max(a,max(b,c)); };
inline long max4(long a,long b,long c,long d)
   { return max(max(a,b),max(c,d)); };

extern int REAL_debug;
extern int REAL_inlimit;
extern int REAL_infinite;

class ITERATION_STACK {
public:
  ITERATION_STACK();
  jmp_buf actual_jmp_buf;
  REAL*   OBJECT_LIST;
  long prec_diff;
  long prec_policy; 
};

extern ITERATION_STACK * ACTUAL_STACK;

extern int debug;
extern int inlimit;
extern long printfausgaben;
extern long printfaufrufe;
extern char * eingabe;
extern char * position;

extern  long testanzahl;
extern  long testaufrufe;
extern  long * testwert;
extern  MP_type * konvert;
extern  long konvertanzahl;
extern  long konvertaufrufe;

extern long REAL_starting_prec;
extern long REAL_actual_prec;
extern long REAL_prec_inc;
extern long REAL_prec_inc1;
extern long REAL_prec_inc2;
extern double REAL_prec_factor;

#define debug REAL_debug
#define inlimit REAL_inlimit
#define infinite REAL_infinite
#define starting_prec REAL_starting_prec
#define actual_prec REAL_actual_prec
#define prec_inc REAL_prec_inc
#define prec_inc1 REAL_prec_inc1
#define prec_inc2 REAL_prec_inc2
#define prec_factor REAL_prec_factor

#ifndef NODEBUG
  #define DEBUG0(level,p) if (REAL_debug>=REAL_inlimit+level) p
  #define DEBUG1(level,p) if (REAL_debug>=REAL_inlimit+level) fprintf(stderr,p)
  #define DEBUG2(level,p1,p2) if (REAL_debug>=REAL_inlimit+level) fprintf(stderr,p1,p2)
  #define DEBUG3(level,p1,p2,p3) if (REAL_debug>=REAL_inlimit+level) fprintf(stderr,p1,p2,p3)
  #define DEBUG4(level,p1,p2,p3,p4) if (REAL_debug>=REAL_inlimit+level) fprintf(stderr,p1,p2,p3,p4)
  #define DEBUG5(level,p1,p2,p3,p4,p5) if (REAL_debug>=REAL_inlimit+level) fprintf(stderr,p1,p2,p3,p4,p5)
  #define DEBUG6(level,p1,p2,p3,p4,p5,p6) if (REAL_debug>=REAL_inlimit+level) fprintf(stderr,p1,p2,p3,p4,p5,p6)
#else
  #define DEBUG0(level,p)
  #define DEBUG1(level,p) 
  #define DEBUG2(level,p1,p2) 
  #define DEBUG3(level,p1,p2,p3) 
  #define DEBUG4(level,p1,p2,p3,p4) 
  #define DEBUG5(level,p1,p2,p3,p4,p5) 
  #define DEBUG6(level,p1,p2,p3,p4,p5,p6)
#endif

#define GUARD_BITS  ( (long) (8*sizeof(SIZETYPEMANTISSA)-3) )

inline void REITERATE(long p_diff){
  while (ACTUAL_STACK->OBJECT_LIST->prev!=ACTUAL_STACK->OBJECT_LIST) {
//    printf("%ld\n",ACTUAL_STACK->OBJECT_LIST->prev);
    ACTUAL_STACK->OBJECT_LIST->prev->clear(); }
  ACTUAL_STACK->prec_diff=p_diff;
  longjmp (ACTUAL_STACK->actual_jmp_buf,-1);
}


inline long scale(long w,long p) {return ((p>GUARD_BITS)?0:(w>>p)); };

inline void sizetype_normalize( sizetype& e) {
  if ( e.mantissa >= ( ((long)1) <<  GUARD_BITS   ) ) 
    {
      e.mantissa =  (e.mantissa>>2) +1; 
      e.exponent += 2;
    } else if ( e.mantissa <  ( 1L << (GUARD_BITS-8) ))
    {
      e.mantissa =  e.mantissa<<6;
      e.exponent -= 6;
    }
  if ( e.exponent < MP_min ) {
    e.exponent = MP_min+8*sizeof(long);
    e.mantissa = 1;
    }
}

inline void sizetype_inc(sizetype& x,sizetype y) 
{ SIZETYPEEXPONENT exponent;
  exponent=max(x.exponent,y.exponent);
  x.mantissa=scale(x.mantissa,(exponent-x.exponent))
            +scale(y.mantissa,(exponent-y.exponent)) +1 ;
  x.exponent=exponent;
  sizetype_normalize(x);
}

inline void sizetype_dec(sizetype& x,sizetype y) 
{ x.mantissa=x.mantissa - scale(y.mantissa,(x.exponent-y.exponent)) -1 ;
  sizetype_normalize(x);
}
inline void sizetype_dec(sizetype& x) 
{ x.mantissa -= 1 ;
}

inline void sizetype_add(sizetype& x,const sizetype y,const sizetype z) 
{
  x.exponent=max(y.exponent,z.exponent);
  x.mantissa=scale(z.mantissa,(x.exponent-z.exponent))
            +scale(y.mantissa,(x.exponent-y.exponent)) +1 ;
  sizetype_normalize(x);
}

inline void sizetype_half(sizetype& x,const sizetype y) 
{
  x.exponent=y.exponent-1;
  x.mantissa=y.mantissa;
}

inline void sizetype_shift(sizetype& x,const sizetype y,const long s) 
{
  x.exponent=y.exponent+s;
  x.mantissa=y.mantissa;
}

inline void sizetype_mult(sizetype& x,const sizetype y,const sizetype z) 
{ unsigned long long lmantissa=
     ((unsigned long long)(y.mantissa))*z.mantissa;
  x.exponent=y.exponent+z.exponent;
  while (lmantissa >= (1<<GUARD_BITS) ) 
       { lmantissa=lmantissa>>4;x.exponent+=4;}
  x.mantissa=lmantissa+1;
  sizetype_normalize(x);
}

inline void sizetype_div(sizetype& x,const sizetype y,const sizetype z) 
{ unsigned long long lmantissa=
         (((unsigned long long)(y.mantissa))<<GUARD_BITS)/z.mantissa;
  x.exponent=y.exponent-z.exponent-GUARD_BITS;
  while (lmantissa >= (1<<GUARD_BITS) )
      { lmantissa=lmantissa>>4;x.exponent+=4; }
  x.mantissa=lmantissa+1;
  sizetype_normalize(x);
}

/*Compute maximum of y and z */
inline void sizetype_max(sizetype& x,const sizetype y,const sizetype z) 
{ if (y.exponent>z.exponent) 
  {
    x.mantissa=scale(z.mantissa,y.exponent-z.exponent);
    if (x.mantissa>=y.mantissa) x=z; else x=y;
  } else {
    x.mantissa=scale(y.mantissa,z.exponent-y.exponent);
    if (x.mantissa>=z.mantissa) x=y; else x=z;
  }
}

/*Test whether  y<z; for y=z the result might be wrong  */
inline int sizetype_less(const sizetype y,const sizetype z) 
{ unsigned long mantissa;
  if (y.exponent>z.exponent) 
  {
    mantissa=scale(z.mantissa,y.exponent-z.exponent);
    return (mantissa>=y.mantissa);
  } else {
    mantissa=scale(y.mantissa,z.exponent-y.exponent);
    return (mantissa<z.mantissa);
  }
}

inline void sizetype_set(sizetype& x,const long mantissa,const long exponent) 
{
  x.exponent=exponent;
  x.mantissa=mantissa;
  sizetype_normalize(x);
}

inline void sizetype_exact(sizetype& x) 
{
  x.exponent=MP_min;
  x.mantissa=0;
}


inline void ADJUST( sizetype& e) {
  if ( e.exponent < MP_min ) printf ("Warning, underflow in exponent!\n");
  if ( e.exponent >= MP_max ) 
  {
    DEBUG1(1,"actual precision infinite, ");
    REITERATE(0);
  }
}

