#include <stdlib.h>
#include <stdio.h>
#include "gmp.h"

#define GMP_min -1000000000
#define GMP_max 1000000000

typedef __mpf_struct  * ext_gmp_type;
typedef struct {unsigned long mantissa; long exponent; } ext_gmp_sizetype;

extern long ext_gmp_var_count;

void ext_gmp_initialize();

ext_gmp_type ext_gmp_init();
void ext_gmp_free(ext_gmp_type z);
long ext_gmp_size(ext_gmp_type z);
void ext_gmp_getsize(ext_gmp_type z,ext_gmp_sizetype* s);

void ext_gmp_add(ext_gmp_type z1,ext_gmp_type z2,ext_gmp_type z,long p);
void ext_gmp_sub(ext_gmp_type z1,ext_gmp_type z2,ext_gmp_type z,long p);
void ext_gmp_mul(ext_gmp_type z1,ext_gmp_type z2,ext_gmp_type z,long p);
void ext_gmp_div(ext_gmp_type z1,ext_gmp_type z2,ext_gmp_type z,long p);
void ext_gmp_abs(ext_gmp_type z1,ext_gmp_type z);
void ext_gmp_truncate(ext_gmp_type z1,ext_gmp_type z);

void ext_gmp_writee(ext_gmp_type z,long w);
void ext_gmp_write(ext_gmp_type z,long w);

void ext_gmp_duplicate_w_init(ext_gmp_type z1,ext_gmp_type *z2);
void ext_gmp_duplicate_wo_init(ext_gmp_type z1,ext_gmp_type z2);

void ext_gmp_sqrt(ext_gmp_type z1,ext_gmp_type z,long p);
void ext_gmp_shift(ext_gmp_type z1,ext_gmp_type z,long p);
