#define DEFINITION_Dyadic

#define BLOCKSIZE	8
/* BLOCKSIZE: Number of Integer Components in a single block
   in the linked data structure
*/
typedef struct S_1 *BlockZeiger;
typedef struct S_1 {
    unsigned int BlockFeld[BLOCKSIZE];
    BlockZeiger BlockNext;
} Block;
typedef struct {
    BOOLEAN negativ;
    long anzahl;
    long highexponent;
    BlockZeiger Wert;
    long reference_count;
} Dyad;
typedef Dyad *Dyadic_Pointer;
typedef struct {unsigned long mantissa; long exponent; } LRsizetype;

extern void Dyadic_LRCLEAR (Dyad* *Z);
extern void Dyadic_LRINIT (Dyad* *Z);
extern void Dyadic_LRTOINT (const Dyad* X, long* I);
extern void Dyadic_LRTOREAL (const Dyad* X, double* R);
extern void Dyadic_LRWRITE (const Dyad* Z, long F);
extern void Dyadic_LRWRITEF (const Dyad* Z, long L, long R);
extern void Dyadic_LRWRITEE (const Dyad* Z, long L);
extern void Dyadic_LRADD (const Dyad* X, const Dyad* Y, Dyad* *Z, long N);
extern void Dyadic_LRSUB (const Dyad* X, const Dyad* Y, Dyad* *Z, long N);
extern void Dyadic_LRMULT (const Dyad* X, const Dyad* Y, Dyad* *Z, long N);
extern void Dyadic_LRMULTKARAT (const Dyad* X, const Dyad* Y, Dyad* *Z, long N);
extern void Dyadic_LRDIV (const Dyad* X, const Dyad* Y, Dyad* *Z, long N);
extern void Dyadic_LRABS (const Dyad* X, Dyad* *Z);
extern void Dyadic_LRINV (const Dyad* X, Dyad* *Z, long N);
extern void Dyadic_LRSQUARE (const Dyad* X, Dyad* *Z, long N);
extern void Dyadic_LRSQRT (const Dyad* X, Dyad* *Z, long N);
extern void Dyadic_LRNEGATE (Dyad* *X);
extern void Dyadic_LRTRUNC (const Dyad*X, Dyad* *Z);
extern void Dyadic_LRFRAC (const Dyad*X, Dyad* *Z);
extern void Dyadic_LRCOPY (const Dyad*X, Dyad* *Z, long N);
extern void Dyadic_LRDUPLICATE (const Dyad*X, Dyad* *Z);
extern void Dyadic_LRSHIFT (const Dyad *X, Dyad* *Z, long I);
extern void Dyadic_LRMULTINT (const Dyad* X, long Y, Dyad* *Z, long N);
extern void Dyadic_LRDIVINT (const Dyad* X, long Y, Dyad* *Z, long N);
extern unsigned long Dyadic_LOG2 (unsigned long N);
extern void Dyadic_LIADD (const Dyad* X, const Dyad* Y, Dyad* *Z);
extern void Dyadic_LISUB (const Dyad* X, const Dyad* Y, Dyad* *Z);
extern void Dyadic_LIMULT (const Dyad* X, const Dyad* Y, Dyad* *Z);
extern void Dyadic_LIMULTKARAT (const Dyad *X, const Dyad *Y, Dyad* *Z);
extern void Dyadic_LIDIV (const Dyad *X, const Dyad *Y, Dyad* *Q, Dyad* *R);
extern void Dyadic_INTTOLR (long W, Dyad* *Z);
extern void Dyadic_DECTOLR (const unsigned char W[], unsigned long , long DExp, Dyad* *Z);
extern long Dyadic_LRSIGN (const Dyad *X);
extern long Dyadic_LRSIZE (const Dyad *X);
extern long Dyadic_LRSIZE (const Dyad *X);
extern void Dyadic_LRGETSIZE(const Dyad *X, LRsizetype* s);
extern long Dyadic_LRCOMPARE (const Dyad *X,const Dyad *Y);
extern long Dyadic_LRLENGTH (const Dyad *X);
typedef void (*Dyadic_LRErrorProc) (int);
extern Dyadic_LRErrorProc Dyadic_LRError;
extern void Dyadic_LRErrorHalt (int Error);
extern void Dyadic_LRErrorIgnore (int Error);
extern void Dyadic_LRErrorStatus (int Error);
extern unsigned long Dyadic_LRVarCount;
extern unsigned long Dyadic_LRSpace ();
extern unsigned long Dyadic_LRmaxSpace ();
extern void BEGIN_Dyadic();
