#ifndef DEFINITION_Dyadic_Base
#include "Dyadic_Base.h"
#endif

/*
#define xLOWx(x) ((x) & MAXNAT)
#define xHIGHx(x) ((x) >> Dyadic_Base_BITZAHL)
#define yLOWy(x,y) ((x) % (y)) 
#define yHIGHy(x,y) ((x) / (y)) 
*/
#define xLOWx(x) ((x) & MAXNAT)
#define xCARRYx(x) ((x) > MAXNAT)
#define xNEGCARRYx(x) ((x) <= MAXNAT)
#define xHIGHx(x) ((unsigned int) ((x) >> Dyadic_Base_BITZAHL))
#define yLOWy(x,y) ((x) % (y)) 
#define yHIGHy(x,y) ((x) / (y)) 

void Dyadic_Base_SysAdd
(Dyadic_Base_WertFeld A, Dyadic_Base_WertFeld B, Dyadic_Base_WertFeld C, long ANZAHL)
{
  unsigned int Sum, *AP, *BP, *CP;
  Sum= 0;
  AP=  &(A[ANZAHL]);
  BP=  &(B[ANZAHL]);
  CP=  &(C[ANZAHL+1]);

  while ( AP>A ) {
    Sum += *(--AP) + *(--BP);
    *(--CP) = xLOWx(Sum);
    Sum = xCARRYx(Sum);
  }
  *(--CP) = Sum;
}

void Dyadic_Base_SysSub
(Dyadic_Base_WertFeld A, Dyadic_Base_WertFeld B, Dyadic_Base_WertFeld C, long ANZAHL, BOOLEAN *NEGATIV)
{
  unsigned int Carry, Sum, *AP, *BP, *CP;

  Carry = 0;
  AP =  &(A[ANZAHL]);
  BP =  &(B[ANZAHL]);
  CP =  &(C[ANZAHL]);
  while ( AP>A ) {
    Sum = BASIS +  *(--AP) - *(--BP) - Carry;
    Carry = xNEGCARRYx(Sum);
    *(--CP) = xLOWx(Sum);
  }

  *NEGATIV = Carry != 0;
  if (*NEGATIV) {
    Carry = 0;
    CP =  &(C[ANZAHL]);
    while ( CP>C ) {
      Sum = BASIS - Carry - *(--CP);
      Carry = xNEGCARRYx(Sum);
      *CP = xLOWx(Sum);
    }
  }
}

/* Noch nicht getestet: 
void Dyadic_Base_SysBlockShl
(Dyadic_Base_WertFeld A, long ANZAHL, long COUNT)
{
  unsigned int ProdCarry, *AP;
  LONGVALUE  Sum;

  ProdCarry = 0;
  AP=&A[ANZAHL-1];
  while (AP >= A ) {
    Sum = ProdCarry + (  ((LONGVALUE) *AP) << COUNT );
    *(AP--) = xLOWx(Sum);
    ProdCarry = xHIGHx(Sum);
  }
}
*/

void Dyadic_Base_SysBlockShl
(Dyadic_Base_WertFeld A, long ANZAHL, long COUNT)
{
  long I;
  unsigned int ProdCarry, LFaktor, *AP;
  LONGVALUE  Sum;

  LFaktor = 1;

  if (1 <= COUNT)
    for (I = 1;; I += 1) {
      LFaktor = LFaktor + LFaktor;
      if (I >= COUNT) break;
    }

  ProdCarry = 0;
  AP=&A[ANZAHL-1];
  while (AP >= A ) {
    Sum = ProdCarry + LFaktor * (LONGVALUE) *AP;
    *(AP--) = xLOWx(Sum);
    ProdCarry = xHIGHx(Sum);
  }
}

void Dyadic_Base_SysMul
(Dyadic_Base_WertFeld A, Dyadic_Base_WertFeld B, Dyadic_Base_WertFeld C, long Aanzahl, long Banzahl, long Canzahl)
{
  unsigned int Faktor, *BP, *CP;
  long ExpA, ExpC, MaxA, MaxB;

  for (ExpC = 0;ExpC <= Canzahl + 1 ; ExpC += 1) C[ExpC] = 0;

  if (Aanzahl <= Canzahl + 2) {
    MaxA = Aanzahl;
  } else {
    MaxA = Canzahl + 2;
  }

  for (ExpA = MaxA; ExpA >= 1; ExpA += -1) {
    Faktor = A[ExpA - 1];
    if (Banzahl <= Canzahl + 2 - ExpA) {
      MaxB = Banzahl;
    } else {
      MaxB = Canzahl + 2 - ExpA;
    }
    ExpC = ExpA + MaxB;
    BP =  &(B[MaxB]);
    CP =  &(C[ExpC]);
    {
      unsigned int  ProdCarry = 0;
      LONGVALUE Prod;   
      while ( BP > B ) {     
        Prod =(LONGVALUE) Faktor *  *(--BP) ;
        Prod += ProdCarry + *(--CP) ;
        *CP   = xLOWx(Prod);
        ProdCarry = xHIGHx(Prod);
      }
      *(--CP) = ProdCarry;
    }
  }
}

void Dyadic_Base_SysDiv
(Dyadic_Base_WertFeld A, Dyadic_Base_WertFeld B, Dyadic_Base_WertFeld C, long Aanzahl, long Banzahl, long Canzahl, BOOLEAN MODUL)
{
  long I, J;
  unsigned int Carry, B1, B2, D, ProdCarry, Asave;
  LONGVALUE Qdach, Rdach, Sum, Prod;

  if (Banzahl < 2) {
    B1 = B[0];
    ProdCarry = 0;
    {
      for (J = 0;J<Canzahl; J += 1) {
        Prod = ProdCarry * (LONGVALUE) BASIS;
        Prod += (J < Aanzahl ? A[J]  : 0) ;
        C[J] = yHIGHy(Prod,B1);
        ProdCarry = yLOWy(Prod,B1);
      }
    }
    A[0] = ProdCarry;
  } else {
    D = yHIGHy(BASIS,(B[0] +1));
    if (D > 1) {
      ProdCarry = 0;
      for (I = Aanzahl; I >= 1; I += -1) {
        Sum = ProdCarry + (LONGVALUE) D * A[I - 1];
        A[I] = xLOWx(Sum);
        ProdCarry = xHIGHx(Sum);
      }
      A[0] = ProdCarry;
      ProdCarry = 0;
      for (I = Banzahl-1; I >= 0; I += -1) {
        Sum = ProdCarry + (LONGVALUE) D * B[I];
        B[I] = xLOWx(Sum);
        ProdCarry = xHIGHx(Sum);
      }
    } else {
      for (I = Aanzahl; I >= 1; I += -1) {
        A[I] = A[I - 1];
      }
      A[0] = 0;
    }
    if (Aanzahl < Banzahl) {
      for (I = Aanzahl + 1 ; I <= Banzahl; I += 1)  A[I] = 0;
      Aanzahl = Banzahl;
    }
    B1 = B[0];
    B2 = B[1];
        for (J = 1; J<= Canzahl; J += 1) {
          if (Banzahl + J <= Aanzahl + 1) {
            A[Banzahl] = A[Banzahl + J - 1];
          } else {
            A[Banzahl] = 0;
          }
          Prod = A[0] * (LONGVALUE) BASIS + A[1];
          if (A[0] == B1) {
            Qdach = MAXNAT;
          } else {
            Qdach = yHIGHy(Prod,B1);
          }
          Rdach = Prod - Qdach * B1;
          for (;;) {
            Sum = Qdach * B2;
/*---------------------------------------------------------
printf("%d %ld %lld\n",Sum, Rdach*BASIS,(unsigned long long) Rdach *  BASIS);
---------------------------------------------------------*/
            if (Sum <= (unsigned long long) Rdach *  BASIS + A[2]) {
              goto EXIT_1;
            } else {
              Qdach -= 1;
              if (MAXNAT - Rdach < B1) {
                goto EXIT_1;
              }
              Rdach += B1;
            }
          } EXIT_1:;
          Carry = 0;
          ProdCarry = 0;
          Asave = A[Banzahl];
          if ( Qdach > BASIS )
          {
          unsigned int *AP=&(A[Banzahl-1]);
          unsigned int *BP=&(B[Banzahl-1]);
          unsigned int Sum;
          while (BP>=B){
            Prod =  Qdach * *(BP--);
            Prod += ProdCarry ;
            ProdCarry = xHIGHx(Prod);
            Sum = BASIS + Asave  - Carry - xLOWx(Prod);
            Carry = xNEGCARRYx(Sum);
            Asave = *(AP);
            *(AP--) = xLOWx(Sum);
          }}
          else
          {
          unsigned int *AP=&(A[Banzahl-1]);
          unsigned int *BP=&(B[Banzahl-1]);
          unsigned int Sum;
          unsigned int Qd=Qdach;
          while (BP>=B){
            Prod =  (LONGVALUE) Qd * *(BP--);
            Prod += ProdCarry ;
            ProdCarry = xHIGHx(Prod);
            Sum = BASIS + Asave  - Carry - xLOWx(Prod);
            Carry = xNEGCARRYx(Sum);
            Asave = *(AP);
            *(AP--) = xLOWx(Sum);
          }}
          Sum = BASIS + Asave - Carry - ProdCarry;
          C[J - 1] = Qdach;
          if (Sum < BASIS) {
            unsigned int Carry = 0;
            unsigned int *AP=&(A[Banzahl-1]);
            unsigned int *BP=&(B[Banzahl-1]);
            unsigned int Sum;
            C[J - 1] -= 1;
            while (BP>=B){
              Sum = Carry + *(AP) + *(BP--);
              *(AP--) = xLOWx(Sum);
              Carry = xCARRYx(Sum);
            }
          }
    }
    if (MODUL) {
      Carry = 0;
      {
        unsigned long B_11 = 1, B_12 = Banzahl;
        if (B_11 <= B_12)
          for (J = B_11;; J += 1) {
            Prod = Carry * (LONGVALUE) BASIS + A[J - 1];
            A[J - 1] = yHIGHy(Prod,D);
            Carry = yLOWy(Prod,D);
            if (J >= B_12) break;
          }
      }
    }
  }
}
