#define DEFINITION_SysLib

typedef int SysLib_SIGNED;
typedef int SysLib_UNSIGNED;
typedef CARDINAL SysLib_inoT;
typedef int SysLib_offT;
typedef SHORTINT SysLib_devT;
typedef int SysLib_timeT;
typedef struct SysLib_1 {
    SysLib_devT stDev;
    SysLib_inoT stIno;
    SHORTCARD stMode;
    SHORTINT stNlink;
    SHORTINT stUid;
    SHORTINT stGid;
    SysLib_devT stRdev;
    SysLib_offT stSize;
    SysLib_timeT stAtime;
    int stSpare1;
    SysLib_timeT stMtime;
    int stSpare2;
    SysLib_timeT stCtime;
    int stSpare3;
    int stBlksize;
    int stBlocks;
    struct SysLib_2 {
        int A[1 + 1];
    } stSpare4;
} SysLib_Stat;
typedef struct SysLib_3 {
    int utime;
    int stime;
    int cutime;
    int cstime;
} SysLib_tms;
#define SysLib_oTRUNC	01000
#define SysLib_oAPPEND	010
#define SysLib_oRDWR	02
#define SysLib_oWRONLY	01
#define SysLib_oRDONLY	00
#define SysLib_pXUSID	04000
#define SysLib_pXGRID	02000
#define SysLib_pSTEXT	01000
#define SysLib_pROWNER	0400
#define SysLib_pWOWNER	0200
#define SysLib_pXOWNER	0100
#define SysLib_pRGROUP	040
#define SysLib_pWGROUP	020
#define SysLib_pXGROUP	010
#define SysLib_pROTHERS	04
#define SysLib_pWOTHERS	02
#define SysLib_pXOTHERS	01
#define SysLib_pEMPTY	00
#define SysLib_cREAD	0X4
#define SysLib_cWRITE	0X2
#define SysLib_cEXEC	0X1
#define SysLib_cEXISTS	0X0
extern SysLib_SIGNED umask ARGS((SysLib_SIGNED cmask));
extern SysLib_SIGNED access ARGS((ADDRESS path, SysLib_SIGNED amode));
extern SysLib_SIGNED creat ARGS((ADDRESS path, SysLib_SIGNED cmode));
extern SysLib_SIGNED open ARGS((ADDRESS path, SysLib_SIGNED oflag));
extern SysLib_SIGNED close ARGS((SysLib_SIGNED fildes));
extern SysLib_SIGNED unlink ARGS((ADDRESS path));
extern SysLib_SIGNED read ARGS((SysLib_SIGNED fildes, ADDRESS buf, SysLib_UNSIGNED nbyte));
extern SysLib_SIGNED write ARGS((SysLib_SIGNED fildes, ADDRESS buf, SysLib_UNSIGNED nbyte));
extern ADDRESS sbrk ARGS((SysLib_SIGNED incr));
extern ADDRESS malloc ARGS((SysLib_UNSIGNED size));
extern void free ARGS((ADDRESS ptr));
extern SysLib_SIGNED stat ARGS((ADDRESS path, SysLib_Stat *buf));
extern SysLib_SIGNED fstat ARGS((SysLib_SIGNED fd, SysLib_Stat *buf));
extern void time ARGS((int *t));
extern void times ARGS((SysLib_tms *buffer));
extern SysLib_SIGNED system ARGS((ADDRESS string));
extern void exit ARGS((SysLib_SIGNED n));
extern void BEGIN_SysLib();
