#include "SYSTEM_.h"

#ifndef DEFINITION_TIMER
#include "TIMER.h"
#endif

typedef int timeT;
typedef struct SysLib_3 {
    timeT utime;
    timeT stime;
    timeT cutime;
    timeT cstime;
} tms;

extern void time    (long *t);
extern void times   (tms *buffer);

static tms t0;
static INTEGER t1;


void TIMER_GetCpuTime (double *T)
{
  tms t;

  times(&t);
  *T = (t.utime - t0.utime) * 10.0;
}

void TIMER_GetAbsTime (double *T)
{
  INTEGER t;

  time(&t);
  *T = (t - t1) * 1000.0;
}

void BEGIN_TIMER()
{
  static BOOLEAN has_been_called = FALSE;

  if (!has_been_called) {
    has_been_called = TRUE;

    times(&t0);
    time(&t1);
  }
}
