extern "C" {

#include "LRGMP_ext.h"

#define MP_type         Dyadic_Dyadic

#define MP_initialize      BEGIN_Dyadic()

#define MP_min    Dyadic_Base_MinInt
#define MP_max    -Dyadic_Base_MinInt

#define MP_init(z)      Dyadic_LRINIT(&(z))

#define MP_clear(z)      Dyadic_LRCLEAR(&(z))
//#define MP_clear(z)      

#define MP_int_to_mp(i,z) Dyadic_INTTOLR(i,&(z))

// duplicate value z1 to z2, with/without initialization of z2 
#define MP_duplicate_w_init(z1,z2)  ext_Dyadic_LRDUPLICATE_w_init(&(z1),&(z2))
#define MP_duplicate_wo_init(z1,z2) Dyadic_LRDUPLICATE(&(z1),&(z2))

// copy z1 to z2, but precision p is sufficient
#define MP_copy(z1,z2,p) Dyadic_LRCOPY(&(z1),&(z2),p)

#define MP_add(z1,z2,z,p) Dyadic_LRADD(&(z1),&(z2),&(z),p)
#define MP_sub(z1,z2,z,p) Dyadic_LRSUB(&(z1),&(z2),&(z),p)
#define MP_mul(z1,z2,z,p) Dyadic_LRMULT(&(z1),&(z2),&(z),p)
#define MP_div(z1,z2,z,p) Dyadic_LRDIV(&(z1),&(z2),&(z),p)
#define MP_abs(z1,z) Dyadic_LRABS(&(z1),&(z))

// MP_compare: values -1 (lessthan), 0 (equal), or 1 (greater than)
#define MP_compare(z1,z2) Dyadic_LRCOMPARE(&(z1),&(z2))

// MP_sign: values -1 (negative), 0 (zero), or 1 (positive)
#define MP_sign(z) Dyadic_LRSIGN(&(z))

// long MP_size : smallest(?) value k such that 2**k > z
#define MP_size(z) Dyadic_LRSIZE(&(z))
#define MP_getsize(z,s) Dyadic_LRGETSIZE(&(z),(LRsizetype*)&(s))

// truncate z1 yielding z2 
#define MP_truncate(z1,z2) Dyadic_LRTRUNC(&(z1),&(z2))

// In/Out
#define MP_writee(z,w) Dyadic_LRWRITEE(&(z),w)
#define MP_writef(z,w,d) Dyadic_LRWRITEF(&(z),w,d)
#define MP_write(z,c) Dyadic_LRWRITE(&(z),c)

// Statistics
#define MP_var_count Dyadic_LRVarCount
#define MP_space_count Dyadic_LRSpace()
#define MP_max_space_count Dyadic_LRmaxSpace()

// special functions
#define MP_has_sqrt 1
#define MP_sqrt(z1,z,n) Dyadic_LRSQRT(&(z1),&(z),n)

#define MP_has_shift 1
#define MP_shift(z1,z,n) Dyadic_LRSHIFT(&(z1),&(z),n)
}
