#include "SYSTEM_.h"
#include <stdio.h>

#ifndef DEFINITION_Dyadic
#include "Dyadic.h"
#endif

#ifndef DEFINITION_LRMLIB
#include "LRMLIB.h"
#endif

#ifndef DEFINITION_TIMER
#include "TIMER.h"
#endif

static Dyadic_Dyadic X, Y, Z;
static int Funktion, Genau, AnfF, EndF, i, g, d, MaxGen,MinGen;
static double D,E, T, Tn, rz[10],x=10.0/3.0,y;
static int Gen[20]={20,50,100,200,500,1000,2000,5000,10000,20000,50000,
	100000,200000,500000,1000000};
static char Name[20][30]={"Addition","Subtraktion","Multiplikation",
"Multiplikation (Karatsuba)","Kehrwert","Division","Quadratwurzel",
"Eulerzahl e ","Exponentiation","Pi","Sinus","10 Orig.Divisionen",
"10 Orig.Multiplikationen","10 Orig.Additionen","10 Orig.Exp/Ln"};


void main()
{
  BEGIN_Dyadic();
  BEGIN_LRMLIB();
  BEGIN_TIMER();

  Dyadic_LRINIT(&X);
  Dyadic_LRINIT(&Y);
  Dyadic_LRINIT(&Z);

  E=2000.0;

  for (i = 1; i <= 15; i += 1) {
    printf("%4d: %s\n",i,Name[i - 1]);
  }
  printf("Anfang bei Funktion: ");
  scanf("%d",&AnfF);
  printf("Ende bei Funktion: ");
  scanf("%d",&EndF);
  printf("Moegliche Genauigkeiten: \n");
  for (i = 1; i <= 15; i += 1) {
    printf("%4d: 2**( - %7d )\n",i,Gen[i - 1]);
  }
  printf("Minimale erwuenschte Genauigkeit: ");
  scanf("%d",&MinGen);
  printf("Maximale erwuenschte Genauigkeit: ");
  scanf("%d",&MaxGen);

  printf("Alle Operationen werden mit dem Wert 10/3 (auf 1500000 Bit) ausgefuehrt\n\n");
  Dyadic_INTTOLR(3, &Y);
  Dyadic_LRINV(&Y, &X,     -1500000);
  Dyadic_LRADD(&X, &Y, &Y, -1500000);
  {
     for (Funktion = AnfF;Funktion <= EndF; Funktion += 1) {
        printf("         %s\n",Name[Funktion - 1]);
        {
            for (Genau = MinGen; Genau <= MaxGen ; Genau += 1) {
              g = -Gen[Genau - 1];
              printf("      2**( -  %7d )",-g);
              d = 1;
              TIMER_GetCpuTime(&T);
              for (;;) {
                switch (Funktion) {
                case 1:;
                  for (i = 1; i  <= d ; i += 1)      Dyadic_LRADD(&Y, &Y, &Z, g);
                  break;
                case 2:;
                  for (i = 1; i  <= d ; i += 1)      Dyadic_LRSUB(&X, &Y, &Z, g);
                  break;
                case 3:;
                  for (i = 1; i  <= d ; i += 1)      Dyadic_LRMULT(&Y, &Y, &Z, g);
                  break;
                case 4:;
                  for (i = 1; i  <= d ; i += 1)     Dyadic_LRMULTKARAT(&Y, &Y, &Z, g);
                  break;
                case 5:;
                  for (i = 1; i  <= d ; i += 1)      Dyadic_LRINV(&Y, &Z, g);
                  break;
                case 6:;
                  for (i = 1; i  <= d ; i += 1)      Dyadic_LRDIV(&Y, &Y, &Z, g);
                  break;
                case 7:;
                  for (i = 1; i  <= d ; i += 1)      Dyadic_LRSQRT(&Y, &Z, g);
                  break;
                case 8:;
                  for (i = 1; i  <= d ; i += 1)      LRMLIB_LREULER(&Z, g);
                  break;
                case 9:;
                  for (i = 1; i  <= d ; i += 1)      LRMLIB_LREXP(&Y, &Z, g);
                  break;
                case 10:;
                  for (i = 1; i  <= d ; i += 1)      LRMLIB_LRPI(&Z, g);
                  break;
                case 11:;
                  for (i = 1; i  <= d ; i += 1)      LRMLIB_LRSINUS(&Y, &Z, g);
                  break;
                case 12:;
                  x=7.0/13.0*d;
                  y=1.0/x;
                  rz[0] = 10.0/3.0;
                 for (i = 1; i  <= d ; i += 1)  {
			rz[1] = rz[0]/x;
			rz[2] = rz[1]/y;
			rz[3] = rz[2]/x;
			rz[4] = rz[3]/y;
			rz[5] = rz[4]/x;
			rz[6] = rz[5]/y;
			rz[7] = rz[6]/x;
			rz[8] = rz[7]/y;
			rz[9] = rz[8]/x;
			rz[0] = rz[9]/y;
			}
                  break;
                case 13:;
                  x=7.0/13.0*d;
                  y=1.0/x;
                  rz[0] = 10.0/3.0;
                  for (i = 1; i  <= d ; i += 1)  {
			rz[1] = x*rz[0];
			rz[2] = y*rz[1];
			rz[3] = x*rz[2];
			rz[4] = y*rz[3];
			rz[5] = x*rz[4];
			rz[6] = y*rz[5];
			rz[7] = x*rz[6];
			rz[8] = y*rz[7];
			rz[9] = x*rz[8];
			rz[0] = y*rz[9];
			}
                  break;
                case 14:;
                  x=7.0/13.0*d;
                  y=-x;
                  rz[0] = 10.0/3.0;
                  for (i = 1; i  <= d ; i += 1)  {
			rz[1] = x+rz[0];
			rz[2] = y+rz[1];
			rz[3] = x+rz[2];
			rz[4] = y+rz[3];
			rz[5] = x+rz[4];
			rz[6] = y+rz[5];
			rz[7] = x+rz[6];
			rz[8] = y+rz[7];
			rz[9] = x+rz[8];
			rz[0] = y+rz[9];
			}
                  break;
                case 15:;
		  rz[0]= 10.0/3.0;
                  for (i = 1; i  <= d ; i += 1)  {
			rz[1] = exp(rz[0]);
			rz[2] = log(rz[1]);
			rz[3] = exp(rz[2]);
			rz[4] = log(rz[3]);
			rz[5] = exp(rz[4]);
			rz[6] = log(rz[5]);
			rz[7] = exp(rz[6]);
			rz[8] = log(rz[7]);
			rz[9] = exp(rz[8]);
			rz[0] = log(rz[9]);
			}
                  break;
                }
                TIMER_GetCpuTime(&Tn); D= Tn - T ;
               if (D > E) break;
                d = 2 * d;
              }
              d = 2 * d - 1;
              if ( D/d <1 )
                printf("  %12.6f us (%d in %f ms) \n", 1000*D / d,d,D);
              else
                printf("  %12.6f ms (%d in %f) \n", D / d,d,D);
            }
        }
        printf("\n");
      }
  }
}
