#include "REALLIB.h"

//---------------------------------------------------------------------
// Compute an approximation to e=2.71.. up to an error of 2^p
 REAL e_approx (long p)
{
  if ( p >= 2 ) return 0;

  REAL z=1,y=z;
  long i=1;
  while ( !bound(y,p) ) {
    y=y/i;
    z=z+y;
    i+=1;
  }
  return z;
};

//---------------------------------------------------------------------
// Compute the exact value of  e=2.71.. 
REAL e()
{
  return limit(e_approx);
};


//---------------------------------------------------------------------
// Compute e=2.71..., then ask for a number of desired decimals, 
// transform this to the corresponding number of binary digits,
// then print e with the necessary precision:
void compute(){

  REAL euler_number=e();

  long deci_places;
  rprintf("Desired Decimals: ");  
  rscanf("%ld",&deci_places);

  long bin_prec=-10*deci_places/3;
 
  rwrite(euler_number,bin_prec,deci_places+8);  
  rprintf("\n");
};


// example input/output of "echo 65|e_example":
// Desired Decimals: 65
//+.27182818284590452353602874713526624977572470936999595749669676277E+0001
                  
