#include "REALS.h"

/* Compute iterated system x=3.75*x*(1-x) (Kulisch) */

void itsyst_double(int count){
  double x = 0.5;
  double c = 3.75;
  x = 0.5;
  c = 3.75;

  for ( int i=0; i<=count; i++ ) {
    if ( (i<100) || (i%10)==0 ) {
      rprintf("%13.10f",x); rprintf(" %d\n",i);
    }
   x= c*x*(1-x);
  }
}


void itsyst_REAL(int count){

  REAL x = 0.5;
  REAL c = 3.75;

// 0.5 and 3.75 can be represented exactly as double, so 
// c=3.75 and c="3.75" are the same, but the latter is a lot slower!

  for ( int i=0; i<=count; i++ ) {
    if ( (i<100) || (i%10)==0 ) {
      rwrite(x,-50,18); rprintf(" %d\n",i);
    }
    x= c*x*(1-x);
  }
}


void compute(){
  int test,count;
  rprintf("Iterated functions system: x = 3.75*x*(1-x)\n");
  rprintf("how to compute (1=REAL, 2=double) : ");
  rscanf("%d",&test);
  rprintf("how many values: ");
  rscanf("%d",&count);
  switch (test) {
     case 1:;
       itsyst_REAL(count);
     break;
     case 2:;
       itsyst_double(count);
     break;
  }


};
