#include <math.h>
#include <stdlib.h>
#include <stdarg.h>
//#include <string.h>

#include "REALcore.h"

// Implementation of class DYADIC ********************
long DYADIC::precision=0;

DYADIC::DYADIC() {
   MP_init(value);
   MP_int_to_mp(0,value);
};

DYADIC::DYADIC(MP_type  y) {
  value=y;
// printf("TRANSFER(DYADIC):  %lu -> %lu\n",&y,&value);
//  MP_duplicate_w_init(y,value);
};

DYADIC::DYADIC(const long i) {
   MP_init(value);MP_int_to_mp(i,value);
};

DYADIC::DYADIC(const DYADIC& y) { 
  MP_duplicate_w_init(y.value,value);
};

DYADIC::~DYADIC() { 
  MP_clear(value);
};

DYADIC operator + (const DYADIC& x, const DYADIC& y) {
  MP_type zvalue;
  MP_init(zvalue);
  MP_add(y.value,x.value,zvalue,DYADIC::precision);
  return zvalue;
};

DYADIC operator - (const DYADIC& x, const DYADIC& y) {
  MP_type zvalue;
  MP_init(zvalue);
  MP_sub(y.value,x.value,zvalue,DYADIC::precision);
  return zvalue;
};

DYADIC operator - (const DYADIC& x) {
  DYADIC y;
  MP_type zvalue;
  MP_init(zvalue);
  MP_sub(y.value,x.value,zvalue,DYADIC::precision);
  return zvalue;
};



DYADIC operator * (const DYADIC& x, const DYADIC& y) {
  MP_type zvalue;
  MP_init(zvalue);
  MP_mul(y.value,x.value,zvalue,DYADIC::precision);
  return zvalue;
};

DYADIC operator / (const DYADIC& x, const DYADIC& y) {
  MP_type zvalue;
  MP_init(zvalue);
  MP_div(x.value,y.value,zvalue,DYADIC::precision);
  return zvalue;
};

DYADIC& DYADIC::operator = (const DYADIC& y) {
  MP_duplicate_wo_init(y.value,value);
  return (*this);
};

bool operator < (const DYADIC& x, const DYADIC& y) {
  long erg=MP_compare((x.value),(y.value));
  return  (erg==-1);
};

bool operator <= (const DYADIC& x, const DYADIC& y) {
  long erg=MP_compare((x.value),(y.value));
  return  (erg!=1);
};

bool operator > (const DYADIC& x, const DYADIC& y) {
  long erg=MP_compare((x.value),(y.value));
  return  (erg==1);
};

bool operator >= (const DYADIC& x, const DYADIC& y) {
  long erg=MP_compare((x.value),(y.value));
  return  (erg!=-1);
};

bool operator == (const DYADIC& x, const DYADIC& y) {
  long erg=MP_compare((x.value),(y.value));
  return  (erg==0);
};

bool operator != (const DYADIC& x, const DYADIC& y) {
  long erg=MP_compare((x.value),(y.value));
  return  (erg!=0);
};

void rwrite (const DYADIC& x,const long w){
int width=w;
if (inlimit) {
    DEBUG1(0,"illegal output in continuous section!\n"); 
    return;
  }
  if (printfausgaben > printfaufrufe)  { 
    printfaufrufe++;
    } else  {
    printfausgaben++;
    printfaufrufe++;
    if (width<10) width=10;
    MP_writee(x.value,width);
    }
}

long size (const DYADIC& x) {
  return MP_size((x.value));
};

DYADIC abs (const DYADIC& x) {
  MP_type zvalue;
  MP_init(zvalue);
  MP_abs(x.value,zvalue);
  return zvalue;
};

